import logging
import formencode
import formencode.htmlfill

from pylons import config, request
from pylons.controllers.util import redirect
from repoze.what.plugins.pylonshq import ControllerProtector

from webhelpers.paginate import Page

from sloecode.lib.base import BaseController
from sloecode.lib.predicates import has_site_role
from sloecode.model.person import Person, PersonSchema
from sloecode.model.site_role import SiteRole, USER_ADMIN
from sloecode.model.meta import Session
import sloecode.lib.helpers as h

log = logging.getLogger(__name__)


@ControllerProtector(has_site_role(role=USER_ADMIN))
class PersonController(BaseController):
    """PersonController renders pages for the person model.
    """
    def index(self, person_name):
        ppl = Person.get(login=person_name)
        person = None
        if len(ppl):
            person = ppl[0]
            
        return self.render('/person-details.html', {'person' : person})