"""Helper functions

Consists of functions to typically be used within templates, but also
available to Controllers. This module is available to templates as 'h'.
"""

# import webhelpers html tags. These can be patched as we want. However, I may
# in the future use the formencode field functions, wrapping them up in simple
# functions here. That way we can add a bit more intelligence in our web forms.
from webhelpers.html.tags import form, end_form, text, password, submit, checkbox
from webhelpers.html.tags import stylesheet_link, ModelTags, hidden, select
from webhelpers.html.tags import checkbox as checkbox

# a simple patch to the checkbox function that shows the caption value as well
#def checkbox(name, value='1', checked=False, label=None, **kwargs)
# a simple link_to implementation that handles a confirm kwarg that prints
# very simple javascript asking the user if they really want to continue.
from webhelpers.html.tags import link_to as _link_to
def link_to(label, url, **kwargs):
    # only add JS if the user has not already put something in onclick handler
    if 'confirm' in kwargs and 'onclick' not in kwargs:
        kwargs['onclick'] = 'return window.confirm("%s")' % (kwargs['confirm'])
    return _link_to(label, url, **kwargs)


# this allows controllers to show informative messages to users:
from webhelpers.pylonslib import Flash as _Flash
#
# To use this from a controller (assuming this module is imported as 'h'), do
# this:
#
# h.flash("Some Message Text")
#
# You may also include a category:
#
# h.flash("Some Message Text", "warning")
#
# Allowed categorioes are warning, notice, error, success. The default
# category is 'notice'.
flash = _Flash()

# import helper functions that let templates determine if the user has
# certain permissions:
from sloecode.lib.security import has_site_role, has_project_role
# import site role names as well:
from sloecode.model.site_role import USER_ADMIN, PROJECT_ADMIN
