from repoze.what.predicates import Predicate

import sloecode.lib.security as security


class has_site_role(Predicate):
    message = 'You must be a "%(role_wanted)s" to access this resource.'

    def __init__(self, role, **kwargs):
        self.role_wanted = role
        super(has_site_role, self).__init__(**kwargs)

    def evaluate(self, environ, credentials):
        try:
            if not security.has_site_role(self.role_wanted):
                self.unmet()
        except KeyError:
            self.unmet()


